#cs ----------------------------------------------------------------------------

 Copyright (C) 2014  Sebastian Walter (chesstiger) [Edit by ProgrammingDonkey]

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.

 AutoIt Version: 3.3.10.0

#ce ----------------------------------------------------------------------------
#include "BASSFX.au3"


Func _Bass_SetEQ($hStream, $aSets, $aFreqs)
	Local $hFX, $sParamStd
	$hFX = _BASS_ChannelSetFX($hStream, $BASS_FX_BFX_PEAKEQ, 0)
	$sParamStd = "%i|2.5|0|%s|%s|-1"
	for $i = 0 to UBound($aFreqs)-1 step +1
		_BASS_FXSetParameters($hFX, StringFormat($sParamStd, $i, $aFreqs[$i], $aSets[$i]))
	Next
	Return $hFX
EndFunc

Func _Bass_RemEQ($hStream, $hFX)
	_BASS_ChannelRemoveFX($hStream, $hFX)
EndFunc