#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Compression=4
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#Region Setup
;Includes
#include <GUIConstants.au3>
StartLoadScreen()
#include <GUIScrollbars_Ex.au3>
#include <WinAPI.au3>
#include <WinAPIConstants.au3>
#include <BASSFX.au3>
#include <ComboConstants.au3>
#include <StructureConstants.au3>
#include <EditConstants.au3>
#include <StringConstants.au3>
#include <ListViewConstants.au3>
#include <Bass.au3>
#include <BassConstants.au3>
#include <BassEQ.au3>
#include <GUIListView.au3>
#include <Array.au3>
#include <Sound.au3>
#include <FileExplorerTreeAndListview UDF.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <GDIPlus.au3>
#include <GuiComboBoxEx.au3>
#include <ProgressBarEx.au3>
Opt("GUIOnEventMode", 1)
;Vars e.t.c
Start()
Global $IniFile = "Settings.ini"
If not FileExists($IniFile) Then FileWrite($IniFile,"[Start Dictionary]|C:\"&@CRLF&"[Files]"&@CRLF&"[EQ]"&@CRLF&"[COLORS]|0x666666|0x555555|0xFF0000|0x5555FF|0x9999FF|0x5555FF|0x555555|0xFFFFFF")
$aIniContent = StringSplit(FileRead($IniFile), @CRLF, BitOR($STR_NOCOUNT, $STR_ENTIRESPLIT))
Global $Colors = StringSplit($aIniContent[3], "|", BitOR($STR_NOCOUNT, $STR_ENTIRESPLIT))
_ArrayDelete($Colors, 0)
; ##########################################################################################################0: MainGuiBG; 1: MainGuiButtonBG; 2: MainGuiButtonCloseBGH; 3: MainGuiButtonMinimizeBGH; 4: ListViewPlaying; 5: MusicCtrlButtons; 6: ListViewBG; 7: ListViewColor
Global Const $AC_SRC_ALPHA = 1
Global $aPlaylist[0]
Global $hGUIEQBtn, $aEQSettingFreq[0], $aEQSettingSet[0], $bDeleteEmpty = False, $EQ = False, $bPassword = False, $sPassword = ""
Global $EQMin = -4, $EQMax = 4, $hGUIEQItemInput[0], $hGUIEQItemSlider[0], $MainGui_Width = @DesktopWidth, $MainGui_Height = @DesktopHeight
Global $oShellApp = ObjCreate ("shell.application")
Global $HoverControls[0][3]
Global $ImagePaths=["Images\MainGui_CloseButton.png","Images\MainGui_MinimizeButton.png"]; 0: Close; 1: Minimize
global $AccelsOn = False, $PlayedOnce = 0, $aEQChecked[0], $hGUIStart, $hGUIStartProgress, $Mode = 0,$hFX = 0,$Time = -2,$Length = 0, $hGUIEQListItem[0],$hGUIListItem[0],$fileindex = -1,$MusicHandle = "",$IsPlaying = -1,$file = "",$iPlaying=0,$Dragging=false,$oldPlayed=-1,$CheckVolumeSlider=true,$VolumeSlider=100,$aktDevice=[-1,""]
global $sSearchContent = "", $iMasterIn=0,$iMasterOut=0,$MusicHandleOld,$outFading=false,$TDragging=false,$ToolTipText="Lade Playlist ",$PDragging=false,$iDropItem
global $MainGui_Width=@DesktopWidth,$MainGui_Height=@DesktopHeight,$gaDropFiles[1],$border=[GUIx(25), GUIy(50)];top|left
Global $iSpeedSetting = 0, $iVolumeSetting = 100, $iSpeedStandard = 0
$hGUI = GUICreate("BeatIt", $MainGui_Width, $MainGui_Height,0,0, $WS_POPUP, $WS_EX_ACCEPTFILES);BitOR($GUI_SS_DEFAULT_GUI, $WS_SIZEBOX, $WS_MAXIMIZEBOX),
GUISetFont(15, 100, Default, "Century Gothic", $hGUI)
GUISetBkColor($Colors[0])
;_WinAPI_SetLayeredWindowAttributes($hGUI, 0x585858)
GUICtrlSetDefBkColor($Colors[1])
$MainGui_MinimizeButton=GUICtrlCreateLabel("-",$MainGui_Width-60,0,30,30,$ES_CENTER)
GUICtrlSetBkColor(-1,$Colors[1])
GUICtrlSetColor(-1, 0xFFFFFF)
GUICtrlSetFont(-1, 15, 1000, -1, "Arial")
GUICtrlSetOnEvent(-1,"_minimize")
_RegisterHover($MainGui_MinimizeButton,"_MinimizeHovered")
GUICtrlSetOnEvent($MainGui_MinimizeButton,"_minimize")
$MainGui_CloseButton=GUICtrlCreateLabel("X",$MainGui_Width-30,0,30,30,$ES_CENTER)
GUICtrlSetBkColor(-1,$Colors[1])
GUICtrlSetColor(-1, 0xFFFFFF)
GUICtrlSetFont(-1, 15, 1000, -1, "Arial")
GUICtrlSetOnEvent(-1,"Stop")
_RegisterHover($MainGui_CloseButton,"_CloseHovered")
GUICtrlSetOnEvent($MainGui_CloseButton,"Stop")
$hGUITime = GUICtrlCreateLabel(@HOUR&":"&@MIN&":"&@SEC, $MainGui_Width-30-30-120-5, 0, 120, 30, $ES_CENTER)
GUICtrlSetBkColor(-1,$Colors[1])
GUICtrlSetColor(-1, 0xFFFFFF)
GUICtrlSetFont(-1, 20, 1000, -1, "Arial")
$hGUIPassword = GUICtrlCreateLabel("Lock", $MainGui_Width-30-30-120-5-120-5, 0, 120, 30, $ES_CENTER)
GUICtrlSetBkColor(-1,$Colors[1])
GUICtrlSetColor(-1, 0xFFFFFF)
GUICtrlSetFont(-1, 20, 1000, -1, "Arial")
GUICtrlSetOnEvent(-1, "PassOnOff")
$FolderInput = GUICtrlCreateInput("", GUIx(5), $border[1]+GUIy(5), GUIx(245), GUIy(40))
$FolderButton = GUICtrlCreateButton("Open", GUIx(5)+GUIx(245), $border[1]+GUIy(5), GUIx(50), GUIy(40))
GUICtrlSetOnEvent(-1, "_FolderNavigate")
$FolderTree=GUICtrlCreateTreeView(GUIx(5),$border[1]+GUIy(5)+GUIy(40+5),GUIx(295),GUIy(425))
GUICtrlSetColor(-1, 0xFFFFFF)
$FolderList=GUICtrlCreateListView("",GUIx(5),$border[1]+GUIy(425+5+50+5),GUIx(295),GUIy(460))
__TLE_setContentFilter(".mp3.wav.wma.m4a.aac.ogg")
__TLE_setListviewBGColor($Colors[6])
__TLE_setListviewColor($Colors[7])
$oExplorer=_TLE_CreateTreeViewExplorer(true,$FolderTree,$FolderList)
$iLVStyle = BitOR($LVS_REPORT, $LVS_SHOWSELALWAYS)
$iLVExtStyle = BitOR($WS_EX_CLIENTEDGE, $LVS_EX_GRIDLINES, $LVS_EX_CHECKBOXES, $LVS_EX_FULLROWSELECT)
$hGUIListSearch = GUICtrlCreateInput("", GUIx(300+5),$border[1]+GUIy(5), GUIx(530), GUIy(40))
GUICtrlSetResizing(-1, 1)
$hGUIList = GUICtrlCreateListView("Path|Filename|Title|Artist|Album|Length|kBit/s",GUIx(300+5),$border[1]+GUIy(5+40), GUIx(530), GUIy(700-40), BitOR($LVS_REPORT, $LVS_SHOWSELALWAYS), BitOR($WS_EX_CLIENTEDGE, $LVS_EX_CHECKBOXES, $LVS_EX_FULLROWSELECT, $LVS_EX_INFOTIP))
GUICtrlSetColor(-1, $Colors[7])
GUICtrlSetResizing(-1, 1)
GUICtrlSetState(-1, $GUI_DROPACCEPTED)
_GUICtrlListView_SetColumnWidth(-1,0,0)
_GUICtrlListView_SetColumnWidth(-1,1,250)
$hGUIListContext = GUICtrlCreateContextMenu($hGUIList)
$hGUIListContextPlay = GUICtrlCreateMenuItem("Play", $hGUIListContext)
GUICtrlSetOnEvent(-1,"_ListContextPlay")
$hGUIListContextDelete = GUICtrlCreateMenuItem("Delete", $hGUIListContext)
GUICtrlSetOnEvent(-1,"_ListContextDelete")
$hGUIPlayPause = GUICtrlCreateButton(ChrW(9658)&@CRLF, GUIx((1000-300-5)/2+300+5), $border[0]+GUIy(5 + 700 +5+5), GUIx(50), GUIy(50))
GUICtrlSetOnEvent(-1,"_playPause")
GUICtrlSetBkColor(-1,$Colors[5])
GUICtrlSetResizing(-1, 1)
$hGUIBackwards = GUICtrlCreateButton("<<", GUIx((1000-300-5)/2+300+5-40), $border[0]+GUIy(5 + 700 +5+5),  GUIx(40), GUIy(40))
GUICtrlSetOnEvent(-1,"Playprevious")
GUICtrlSetBkColor(-1,$Colors[5])
GUICtrlSetResizing(-1, 1)
$hGUIForwards = GUICtrlCreateButton(">>", GUIx((1000-300-5)/2+300+5+50), $border[0]+GUIy(5 + 700 +5+5),  GUIx(40), GUIy(40))
GUICtrlSetOnEvent(-1,"Playnext")
GUICtrlSetBkColor(-1,$Colors[5])
GUICtrlSetResizing(-1, 1)
$hGUIMode = GUICtrlCreateButton(">", GUIx((1000-300-5)/2+300+5), $border[0]+GUIy(5 + 700 +5+5+50), GUIx(50), GUIy(25))
GUICtrlSetFont(-1, 8)
GUICtrlSetOnEvent(-1,"_PlayMode")
GUICtrlSetBkColor(-1,$Colors[5])
GUICtrlSetResizing(-1, 1)
$hGUIPosition = GUICtrlCreateSlider(GUIx(300+5), GUIy(1000-30),GUIx(1000-300-5-5),GUIy(30))
GUICtrlSetBkColor(-1,$Colors[0])
GUICtrlSetResizing(-1, 1)
$hGUIPositionL = GUICtrlCreateLabel("00:00:00 / 00:00:00", GUIx(300+5+5), GUIy(1000-30-30),GUIx(1000-300-5-5),GUIy(30))
GUICtrlSetBkColor(-1,$Colors[0])
GUICtrlSetResizing(-1, 1)
GUICtrlCreateLabel("Volume:",0+310,$border[0]+500+10)
GUICtrlSetBkColor(-1,$Colors[0])
$hGUITitle = GUICtrlCreateLabel("Title", GUIx(300+5),$border[1]+GUIy(5 + 700 +5+5), GUIx((1000-300-5)/2-40), GUIy(30))
GUICtrlSetBkColor(-1,$Colors[0])
$hGUIArtist = GUICtrlCreateLabel("Artist", GUIx(300+5),$border[1]+GUIy(5 + 700 +5+5+30), GUIx((1000-300-5)/2-40), GUIy(30))
GUICtrlSetBkColor(-1,$Colors[0])
$hGUIPlayNumber = GUICtrlCreateLabel("0 / 0", GUIx(300+5),$border[1]+GUIy(5 + 700 +5+5+30+30), GUIx((1000-300-5)/2-40), GUIy(30))
GUICtrlSetBkColor(-1,$Colors[0])
$hGUISwitchEQ = GUICtrlCreateButton("Off", GUIx(300+5+530+5), $border[1]+GUIy(5+700-40), GUIx(160), GUIy(40))
GUICtrlSetOnEvent(-1, "EQOnOff")
$hGUIDummySelectAll = GUICtrlCreateDummy()
GUICtrlSetOnEvent(-1, "DummySelectAll")
$hGUIEQ = GUICreate("EQTest", GUIx(160), GUIy(700-40), GUIx(300+5+530+5), $border[1]+GUIy(5), BitOR($WS_CHILD, $WS_POPUP))
GUISetBkColor($Colors[6])
GUISetFont(15, 100, Default, "Century Gothic", $hGUIEQ)
$hGUIEQVolumeLabel = GUICtrlCreateLabel("Vol:", GUIx(5), GUIy(5) + 0 * GUIy(50), GUIx(50), GUIy(40), $ES_RIGHT)
GUICtrlSetBkColor(-1, $Colors[6])
$hGUIEQVolumeSlider = GUICtrlCreateSlider(GUIx(5 + 50 + 5), GUIy(5) + 0 * GUIy(50), GUIx(100), GUIy(40), $TBS_HORZ)
GUICtrlSetBkColor(-1, $Colors[6])
GUICtrlSetLimit(-1, 100, 0)
GUICtrlSetData(-1, 100)
$hGUIEQSpeedLabel = GUICtrlCreateLabel("Rate:", GUIx(5), GUIy(5) + 1 * GUIy(50), GUIx(50), GUIy(40), $ES_RIGHT)
GUICtrlSetBkColor(-1, $Colors[6])
$hGUIEQSpeedSlider = GUICtrlCreateSlider(GUIx(5 + 50 + 5), GUIy(5) + 1 * GUIy(50), GUIx(100), GUIy(40), $TBS_HORZ)
GUICtrlSetBkColor(-1, $Colors[6])
GUICtrlSetLimit(-1, 10000, 10)
GUICtrlSetData(-1, 1000)
$hGUIEQContext = GUICtrlCreateContextMenu()
$hGUIEQContextAdd = GUICtrlCreateMenuItem("Add Frequency", $hGUIEQContext)
$hGUIEQContextDelete = GUICtrlCreateMenuItem("Delete 0", $hGUIEQContext)
_WinAPI_SetParent($hGUIEQ, $hGUI)
GUICtrlSetOnEvent($hGUIEQContextAdd, "EQAddFreq")
GUICtrlSetOnEvent($hGUIEQContextDelete, "EQDeleteReg")
GUISwitch($hGUI)
SetAccels(1)
_GUIScrollBars_Generate($hGUIEQ, 0, GUIy(5))
Restore()
GUIRegisterMsg($WM_NOTIFY, '_WM_NOTIFY')
GuiRegisterMsg($WM_COMMAND,"MY_WM_COMMAND")
GUISetOnEvent($GUI_EVENT_PRIMARYUP, '_LVDrop')
GUISetOnEvent($GUI_EVENT_PRIMARYDOWN, '_LVDrag')
GUISetOnEvent($GUI_EVENT_MOUSEMOVE, '_LVMove')
GUISetOnEvent($GUI_EVENT_CLOSE, 'Stop')
aktDevices()
#EndRegion
$Times = 0
#Region Loop
$sTLEPath = ""
#cs
Dim $ABC[2][2]
Dim $ABCD[2][2]
$ABCD[0][0] = 1
$ABCD[0][1] = 2
$ABCD[1][0] = 3
$ABCD[1][1] = 4
#ce
StopLoadScreen()
While Sleep(0)
	If GUICtrlRead($hGUIEQVolumeSlider)/100 <> $iVolumeSetting Then
		_BASS_ChannelSetAttribute($MusicHandle, $BASS_ATTRIB_VOL, GUICtrlRead($hGUIEQVolumeSlider)/100)
		$iVolumeSetting = GUICtrlRead($hGUIEQVolumeSlider)/100
	EndIf
	If GUICtrlRead($hGUIEQSpeedSlider)*10 <> $iSpeedSetting Then
		$iSpeedSetting = GUICtrlRead($hGUIEQSpeedSlider)*10
		_BASS_ChannelSetAttribute($MusicHandle, $BASS_ATTRIB_FREQ, $iSpeedSetting)
	EndIf
	if $TDragging then
		ToolTip("Fge den Ordner und alle Unterordner der Playlist hinzu.")
	EndIf
	If $sTLEPath <> _TLE_getActPath($oExplorer) Then
		$sTLEPath = _TLE_getActPath($oExplorer)
		GUICtrlSetData($FolderInput, $sTLEPath)
	EndIf
	GUIAct()
WEnd
#EndRegion
#Region GUIAct
Func GUIAct()
	EQShow()
	_Hover_Func()
	CheckListSearch()
	If $bDeleteEmpty Then EQDelete()
	If $IsPlaying and $EQ Then EQCheck()
	If GUICtrlRead($hGUIPlayNumber) <> $oldPlayed +1&" / "&_GUICtrlListView_GetItemCount($hGUIList) Then
		GUICtrlSetData($hGUIPlayNumber, $oldPlayed +1&" / "&_GUICtrlListView_GetItemCount($hGUIList))
		GUICtrlSetData($hGUITitle, _GUICtrlListView_GetItemTextArray($hGUIList, $oldPlayed)[3])
		GUICtrlSetData($hGUIArtist, _GUICtrlListView_GetItemTextArray($hGUIList, $oldPlayed)[4])
	EndIf
	$Time = _BASS_ChannelBytes2Seconds($MusicHandle, _BASS_ChannelGetPosition($MusicHandle, $BASS_POS_BYTE))
	If Round($Time) <> $Times Then
		$Times = Round($Time)
		GUICtrlSetData($hGUIPosition, Round($Time))
		GUICtrlSetData($hGUIPositionL, _getTimeFromSeconds(Round($Time)) & " / "&_getTimeFromSeconds(Round($Length)))
	EndIf
	If GUICtrlRead($hGUIPosition) <> Round($Time) Then
		$Time = GUICtrlRead($hGUIPosition)
		$MusicHandleOld=$MusicHandle
		$MusicHandle = _BASS_StreamCreateFile(False, _BASS_ChannelGetInfo($MusicHandleOld)[7], 0, 0, 0)
		If $outFading = True Then Fade(1)
		if $aktDevice[0]<>-1 then
			_BASS_ChannelSetDevice($MusicHandle,$aktDevice[0]+1)
		endif
		_BASS_ChannelPlay($MusicHandle, 1)
		_BASS_ChannelSetAttribute($MusicHandle, $BASS_ATTRIB_VOL, GUICtrlRead($hGUIEQVolumeSlider)/100)
		_BASS_ChannelSetAttribute($MusicHandle, $BASS_ATTRIB_FREQ, GUICtrlRead($hGUIEQSpeedSlider)*10)
		_BASS_ChannelSetPosition($MusicHandle, _BASS_ChannelSeconds2Bytes($MusicHandle, $Time), $BASS_POS_BYTE)
		Fade(0)
		_BASS_ChannelStop($MusicHandleOld)
		$IsPlaying = 1
		GUICtrlSetData($hGUIPlayPause, "II")
		If $EQ Then EQAct()
	EndIf
	If $Time >= $Length-1 and $IsPlaying<>-1 Then
		if $iPlaying=0 then
			$iPlaying=1
			SongEnd()
		endif
	EndIf
	if $CheckVolumeSlider then
		if $VolumeSlider<>GUICtrlRead($hGUIEQVolumeSlider) then
			$VolumeSlider=GUICtrlRead($hGUIEQVolumeSlider)
			_BASS_ChannelSetAttribute($MusicHandle, $BASS_ATTRIB_VOL, GUICtrlRead($hGUIEQVolumeSlider)/100)
			_BASS_ChannelSetAttribute($MusicHandle, $BASS_ATTRIB_FREQ, GUICtrlRead($hGUIEQSpeedSlider)*10)
		endif
	endif
EndFunc

Func Fade($InOut)
	if $InOut=0 then
		AdlibUnRegister("_FadeIn")
		$iMasterIn=0
		AdlibRegister("_FadeIn",5)
	else
		if $MusicHandleOld<>"" and $outFading then
			_BASS_ChannelStop($MusicHandleOld)
		endif
		$iMasterOut=0
		$outFading=true
		AdlibUnRegister("_FadeOut")
		AdlibRegister("_FadeOut",5)
endif
EndFunc
#EndRegion
#Region Funcs
Func Restore()
	$sIniContent = StringSplit(FileRead($IniFile), @CRLF, BitOR($STR_NOCOUNT, $STR_ENTIRESPLIT))
	$StartFile = StringSplit($sIniContent[0], "|", BitOR($STR_NOCOUNT, $STR_ENTIRESPLIT))[1]
	$ListFiles = StringSplit($sIniContent[1], "|", BitOR($STR_NOCOUNT, $STR_ENTIRESPLIT))
	$EQSettings = StringSplit($sIniContent[2], "|", BitOR($STR_NOCOUNT, $STR_ENTIRESPLIT))
	_TLE_TreeViewOpenPath($StartFile, $oExplorer)
	$WholeNumber  = UBound($ListFiles)+UBound($EQSettings)
	$ActNumber = 0
	$Perc = 0
	If UBound($ListFiles) > 1 and $ListFiles[1] <> "" Then
		for $i = 1 to UBound($ListFiles)-1 step +1
			_addFile($ListFiles[$i])
			$ActNumber += 1
			$Perc = $ActNumber/$WholeNumber*100
			_GUICtrlProgressExSet($hGUIStart, $hGUIStartProgress, $Perc)
		Next
	EndIf
	If UBound($EQSettings) > 1 and $EQSettings[1] <> "" Then
		for $i = 1 to UBound($EQSettings)-1 step +1
			$FreqSet = StringSplit($EQSettings[$i], ":",BitOR($STR_NOCOUNT, $STR_ENTIRESPLIT))
			EQAddFreqEx($FreqSet[0], $FreqSet[1])
			$ActNumber += 1
			$Perc = $ActNumber/$WholeNumber*100
			_GUICtrlProgressExSet($hGUIStart, $hGUIStartProgress, $Perc)
		Next
	EndIf
EndFunc

Func Backup()
	If MsgBox(4, "Save State", "Do you want to save the setup?") = 6 Then
		Local $StartFile =  "[STARTFILE]|"&_TLE_getActPath($oExplorer)
		Local $EQSettings = "[EQ]"
		Local $ListFiles = "[FILES]"
		for $i = 0 to UBound($hGUIEQItemInput)-1 step +1

			$EQSettings &= "|"&GUICtrlRead($hGUIEQItemInput[$i])&":"&GUICtrlRead($hGUIEQItemSlider[$i])
		Next
		for $i = 0 to _GUICtrlListView_GetItemCount($hGUIList)-1 step +1
			$sRow = _GUICtrlListView_GetItemTextArray($hGUIList, $i)
			$ListFiles &=  "|"&$sRow[1]&"\"&$sRow[2]
		Next
		FileDelete($IniFile)
		FileWrite($IniFile, $StartFile&@CRLF&$ListFiles&@CRLF&$EQSettings&@CRLF&"[COLORS]|0x666666|0x555555|0xFF0000|0x5555FF|0x9999FF|0x5555FF|0x555555|0xFFFFFF")
	EndIf
EndFunc

Func StartLoadScreen()
	Global $hGUIStart = GUICreate("BeatIt [StartUp]", 400, 200, @DesktopWidth/2-200, @DesktopHeight/2-100, $WS_POPUP)
	GUISetBkColor(0x666666)
	GUICtrlCreateLabel("BeatIt", 0, 0, 400, 150, $ES_CENTER)
	GUICtrlSetColor(-1, 0xFFFFFF)
	GUICtrlSetFont(-1, 100, 100, -1, "Century Gothic")
	GUICtrlCreateLabel("MusicPlayer made by David Jandrey", 0,150, 400, 30, $ES_CENTER)
	GUICtrlSetColor(-1, 0xFFFFFF)
	GUICtrlSetFont(-1, 15, 100, -1, "Century Gothic")
	Global $hGUIStartProgress = _GUICtrlProgressExCreate($hGUIStart, 0, 180, 400, 20, 3, 0x999999, 0x888888)
	GUISetState(@SW_SHOW, $hGUIStart)
	for $i = 0 to 255 step +5
		WinSetTrans($hGUIStart, "", $i)
		sleep(1)
	next
EndFunc

Func StopLoadScreen()
	AdlibRegister("SyncTime", 1000)
	GUISetState(@SW_SHOW, $hGUI)
	GUISetState(@SW_SHOW, $hGUIEQ)
	for $i = 0 to 255 step +5
		WinSetTrans($hGUI, "", $i)
		WinSetTrans($hGUIEQ, "", $i)
		WinSetTrans($hGUIStart, "", 255-$i)
		sleep(1)
	Next
	GUISwitch($hGUI)
	GUIDelete($hGUIStart)
EndFunc

Func Start()
	_BASS_STARTUP("bin\bass.dll")
	_BASS_FX_Startup("bin\bass_fx.dll")
	_BASS_Init(0, -1, 100000, 0, "")
	_BASS_Init(0, -1, _Bass_GetInfo()[6], 0, "")
EndFunc

Func aktDevices()
	#cs
	$i=0
	While 1
		$device=_BASS_GetDeviceInfo($i)
		if $device=0 then
			ExitLoop
		endif
		if $device[0]<>"No Sound" then
			_GUICtrlComboBoxEx_AddString($hGUIDeviceCombo,$device[0])
		endif
		$i+=1
	WEnd
	#ce
EndFunc

Func _ListContextDelete()
	If ControlGetHandle($hGUI, "", ControlGetFocus($hGUI)) = ControlGetHandle($hGUI, "", $hGUIList) Then _GUICtrlListView_DeleteItemsSelected($hGUIList)
EndFunc

Func _ListContextPlay()
	$sel=_GUICtrlListView_GetSelectedIndices($hGUIList)
	if $sel<>"" then
		$folder=_GUICtrlListView_GetItemText($hGUIList,int($sel),0)
		$file=_GUICtrlListView_GetItemText($hGUIList,int($sel),1)
		if $oldPlayed<>-1 then
			GUICtrlSetBkColor(_GUICtrlListView_GetItemParam($hGUIList, $oldPlayed),$Colors[6])
		endif
		$oldPlayed=int($sel)
		GUICtrlSetBkColor(_GUICtrlListView_GetItemParam($hGUIList, int($sel)),$Colors[4])
		$file = $folder&"\"&$file
		Play($file)
	endif
EndFunc

Func CheckListSearch()
	$Startnew = False
	$Focus = ControlGetHandle($hGUI, "", ControlGetFocus($hGUI))
	If $Focus = ControlGetHandle($hGUI, "", $hGUIListSearch) Then
		SetAccels(0)
	Else
		SetAccels(1)
	EndIf
	If $sSearchContent <> GUICtrlRead($hGUIListSearch) Then
		$sSearchContent = GUICtrlRead($hGUIListSearch)
		_GUICtrlListView_BeginUpdate($hGUIList)
		_GUICtrlListView_DeleteAllItems($hGUIList)
		for $i = 0 to UBound($aPlaylist)-1 step +1
			if StringInStr($aPlaylist[$i], $sSearchContent) Then
				GUICtrlCreateListViewItem($aPlaylist[$i], $hGUIList)
				If $sSearchContent <> GUICtrlRead($hGUIListSearch) Then
					$Startnew = True
					ExitLoop
				EndIf
			ElseIf $sSearchContent = "" Then
				GUICtrlCreateListViewItem($aPlaylist[$i], $hGUIList)
				If $sSearchContent <> GUICtrlRead($hGUIListSearch) Then
					$Startnew = True
					ExitLoop
				EndIf
			EndIf
		Next
		If $Startnew Then
			CheckListSearch()
		 Else
			_GUICtrlListView_EndUpdate($hGUIList)
		EndIf
	EndIf
EndFunc

Func _playPause()
	If $IsPlaying = 0 Then
		_BASS_ChannelPlay($MusicHandle, 0)
		_BASS_ChannelSetAttribute($MusicHandle, $BASS_ATTRIB_VOL, 0)
		Fade(0)
		$IsPlaying = 1
		GUICtrlSetData($hGUIPlayPause, "II")
	ElseIf $IsPlaying = 1 Then
		while $outFading
		WEnd
		$MusicHandleOld=$MusicHandle
		Fade(1)
		while $iMasterOut<$VolumeSlider
			sleep(5)
		WEnd
		_BASS_ChannelPause($MusicHandle)
		$IsPlaying = 0
		GUICtrlSetData($hGUIPlayPause, ChrW(9658))
	ElseIf $isPlaying = -1 Then
		Playnext()
	EndIf
EndFunc

Func _PlayMode()
	If $Mode = 3 Then
		$Mode = 0
		GUICtrlSetData($hGUIMode, ">")
	ElseIf $Mode = 0 Then
		$Mode = 1
		GUICtrlSetData($hGUIMode, ChrW("8635"))
	ElseIf $Mode = 1 Then
		$Mode = 2
		GUICtrlSetData($hGUIMode, ChrW("8635")&"1")
	ElseIf $Mode = 2 Then
		$Mode = 3
		GUICtrlSetData($hGUIMode, ChrW("10541"))
	EndIf
EndFunc

Func _FolderNavigate()
	If FileExists(GUICtrlRead($FolderInput)) Then
		_TLE_SetListViewFolder(GUICtrlRead($FolderInput), $oExplorer)
		__TLE_openTreePath(GUICtrlRead($FolderInput), $oExplorer)
	Else
		MsgBox(16, "Error", "Ordner existiert nicht.")
	EndIf
EndFunc

Func _FadeOut()
	_BASS_ChannelSetAttribute($MusicHandleOld, $BASS_ATTRIB_VOL, 1-$iMasterOut/100)
	if $iMasterOut=$VolumeSlider then
		AdlibUnRegister("_FadeOut")
		$outFading=false
		if $MusicHandleOld<>"" then
			_BASS_ChannelStop($MusicHandleOld)
		endif
	endif
	$iMasterOut+=1
EndFunc

Func _FadeIn()
	_BASS_ChannelSetAttribute($MusicHandle, $BASS_ATTRIB_VOL, $iMasterIn/100)
	if $iMasterIn=$VolumeSlider then
		AdlibUnRegister("_FadeIn")
	endif
	$iMasterIn+=1
EndFunc

Func Play($file)
	$Length = _SoundLength(_SoundOpen($file), 2) /1000
	if $Length=0 then
		$Laenge =_GetExtProperty($file,-1)
		If $Laenge = 0 Then Return -1
		$Laenge = $Laenge[27]
		if $Laenge<>"" then
			$ar=StringSplit($Laenge,":")
			if $ar[0]>1 then
				$Length=int($ar[1])*60*60+int($ar[2])*60+int($ar[3])
			endif
		endif
	endif
	if $Length<>0 then
		GUICtrlSetLimit($hGUIPosition, $Length)
	else
		MsgBox(16,"Error","Beim ermitteln der Lnge des Titels trat ein Fehler auf!")
		GUICtrlSetLimit($hGUIPosition, "??:??:??")
	endif
		If $MusicHandle <> "" Then
			;Fade(1)
			$MusicHandleOld=$MusicHandle
		EndIf
		$MusicHandle = _BASS_StreamCreateFile(False, $file, 0, 0, 0)
		if $aktDevice[0]<>-1 then
			_BASS_ChannelSetDevice($MusicHandle,$aktDevice[0]+1)
		endif
		_BASS_ChannelPlay($MusicHandle, 1)
		_BASS_ChannelSetAttribute($MusicHandle, $BASS_ATTRIB_VOL, GUICtrlRead($hGUIEQVolumeSlider)/100)
		Global $iSpeedSetting = _BASS_ChannelGetAttribute($MusicHandle, $BASS_ATTRIB_FREQ)/10
		GUICtrlSetData($hGUIEQSpeedSlider, $iSpeedSetting)
		$iSpeedStandard = $iSpeedSetting
		;Fade(0)
		FadeNew()
		$IsPlaying = 1
		GUICtrlSetData($hGUIPlayPause, "II")
		If $EQ Then EQAct()
EndFunc

Func SetEQ($aFreqs, $aSets)
	#cs
	If IsArray(_BASS_ChannelGetInfo($MusicHandle)) Then
	$MusicHandleOld=$MusicHandle
	$MusicHandle = _BASS_StreamCreateFile(False, _BASS_ChannelGetInfo($MusicHandleOld)[7], 0, 0, 0)
	if $aktDevice[0]<>-1 then
		_BASS_ChannelSetDevice($MusicHandle,$aktDevice[0]+1)
	endif
	_BASS_ChannelSetAttribute($MusicHandle, $BASS_ATTRIB_VOL, 0)
	#ce
	$hFX = _Bass_SetEQ($MusicHandle, $aSets, $aFreqs)
	#cs
	If $IsPlaying Then _BASS_ChannelPlay($MusicHandle, 1)
	_BASS_ChannelSetPosition($MusicHandle, _BASS_ChannelGetPosition($MusicHandleOld, $BASS_POS_BYTE), $BASS_POS_BYTE)
	FadeNew()
	_BASS_ChannelStop($MusicHandleOld)
	#ce
	return $hFX
	;EndIf
EndFunc

Func FadeNew()
	for $i = 0 to 1 step 0.05
		sleep(5)
		_BASS_ChannelSetAttribute($MusicHandle, $BASS_ATTRIB_VOL, GUICtrlRead($hGUIEQVolumeSlider)/100*$i)
		sleep(5)
		_BASS_ChannelSetAttribute($MusicHandleOld, $BASS_ATTRIB_VOL, 1-GUICtrlRead($hGUIEQVolumeSlider)/100*$i)
	Next
	_BASS_ChannelStop($MusicHandleOld)
EndFunc

Func Stop()
	If $bPassword Then
		If InputBox("Enter Password", "Type in the password:","","*") <> $sPassword Then
			MsgBox(16, "Wrong Password", "You entered the wrong password")
			Return -1
		EndIf
	EndIf
	If _BASS_ChannelIsActive($MusicHandle) Then
		for $i = 1 to 0 step -0.01
			sleep(3)
			_BASS_ChannelSetAttribute($MusicHandle, $BASS_ATTRIB_VOL, $i)
		Next
		_BASS_ChannelStop($MusicHandle)
	EndIf
	_BASS_FREE()
	Backup()
	for $i = 0 to 255 step +5
		WinSetTrans($hGUI, "", 255-$i)
		;WinSetTrans($GUI, "", 255-$i)
		sleep(1)
	next
	Exit
EndFunc

Func _minimize()
	If $bPassword Then
		If InputBox("Enter Password", "Type in the password:","","*") <> $sPassword Then
			MsgBox(16, "Wrong Password", "You entered the wrong password")
			Return -1
		EndIf
	EndIf
	GUISetState(@SW_MINIMIZE,$hGUI)
EndFunc

Func EQBtn()
	If GUICtrlRead($hGUIEQBtn) = "Off" Then
	Local $aFreqs[0]
	Local $aSets[0]
	Global $aEQChecked[0]
	for $i = 0 to _GUICtrlListView_GetItemCount($hGUIEQ)-1 step +1
		If _GUICtrlListView_GetItemChecked($hGUIEQ, $i) Then
			_ArrayAdd($aFreqs, _GUICtrlListView_GetItemTextArray($hGUIEQ, $i)[1])
			_ArrayAdd($aSets, _GUICtrlListView_GetItemTextArray($hGUIEQ, $i)[2])
			_ArrayAdd($aEQChecked, $i)
		EndIf
	next
		GUICtrlSetData($hGUIEQBtn, "On")
		_BASS_ChannelRemoveFX($MusicHandle, $hFX)
		Global $hFX = SetEQ($aFreqs, $aSets)
	Else
		GUICtrlSetData($hGUIEQBtn, "Off")
		_BASS_ChannelRemoveFX($MusicHandle, $hFX)
	EndIf
EndFunc

Func EQAct()
	_BASS_ChannelRemoveFX($MusicHandle, $hFX)
	If $EQ Then
	If UBound($aEQSettingFreq) > 0 Then
		Global $hFX = SetEQ($aEQSettingFreq, $aEQSettingSet)
	EndIf
	EndIf
EndFunc

Func Playnext()
	$sel=_GUICtrlListView_GetSelectedIndices($hGUIList)
	if $sel="" and $oldPlayed=-1 and _GUICtrlListView_GetItemCount($hGUIList)>0 then
		$sel=_GUICtrlListView_GetItemCount($hGUIList)
	endif
	$bool=$sel<>""
	if $oldPlayed<>-1 then
		$sel=$oldPlayed
	endif
	if $oldPlayed<>-1 or ($oldPlayed=-1 and $bool) then
		if $sel+1<_GUICtrlListView_GetItemCount($hGUIList) then
			$folder=_GUICtrlListView_GetItemText($hGUIList,int($sel)+1,0)
			$file=_GUICtrlListView_GetItemText($hGUIList,int($sel)+1,1)
			if $oldPlayed<>-1 then
				GUICtrlSetBkColor(_GUICtrlListView_GetItemParam($hGUIList, $oldPlayed),$Colors[6])
			endif
			$oldPlayed=int($sel+1)
			GUICtrlSetBkColor(_GUICtrlListView_GetItemParam($hGUIList, int($sel)+1),$Colors[4])
			$file = $folder&"\"&$file
			Play($file)
		elseif _GUICtrlListView_GetItemCount($hGUIList)>0 then
			$folder=_GUICtrlListView_GetItemText($hGUIList,0,0)
			$file=_GUICtrlListView_GetItemText($hGUIList,0,1)
			if $oldPlayed<>-1 then
				GUICtrlSetBkColor(_GUICtrlListView_GetItemParam($hGUIList, $oldPlayed),$Colors[6])
			endif
			$oldPlayed=0
			GUICtrlSetBkColor(_GUICtrlListView_GetItemParam($hGUIList, 0),$Colors[4])
			Play($folder&"\"&$file)
		endif
	endif
EndFunc

Func Playprevious()
	If $Mode = 3 Then
		PlayRandom()
		GUICtrlSetData($hGUIPosition, 0)
		return -1
	EndIf
	$sel=_GUICtrlListView_GetSelectedIndices($hGUIList)
	$bool=$sel<>""
	if $oldPlayed<>-1 then
		$sel=$oldPlayed
	endif
	if $oldPlayed<>-1 or ($oldPlayed=-1 and $bool) then
		if $sel-1>=0 then
			$folder=_GUICtrlListView_GetItemText($hGUIList,int($sel)-1,0)
			$file=_GUICtrlListView_GetItemText($hGUIList,int($sel)-1,1)
			if $oldPlayed<>-1 then
				GUICtrlSetBkColor(_GUICtrlListView_GetItemParam($hGUIList, $oldPlayed),$Colors[6])
			endif
			$oldPlayed=int($sel-1)
			GUICtrlSetBkColor(_GUICtrlListView_GetItemParam($hGUIList, int($sel)-1),$Colors[4])
			$file = $folder&"\"&$file
			Play($file)
		elseif _GUICtrlListView_GetItemCount($hGUIList)>0 then
			$folder=_GUICtrlListView_GetItemText($hGUIList,_GUICtrlListView_GetItemCount($hGUIList)-1,0)
			$file=_GUICtrlListView_GetItemText($hGUIList,_GUICtrlListView_GetItemCount($hGUIList)-1,1)
			if $oldPlayed<>-1 then
				GUICtrlSetBkColor(_GUICtrlListView_GetItemParam($hGUIList, $oldPlayed),$Colors[6])
			endif
			$oldPlayed=_GUICtrlListView_GetItemCount($hGUIList)-1
			GUICtrlSetBkColor(_GUICtrlListView_GetItemParam($hGUIList, _GUICtrlListView_GetItemCount($hGUIList)-1),$Colors[4])
			Play($folder&"\"&$file)
		endif
	endif
EndFunc

Func PlayRandom()
	if _GUICtrlListView_GetItemCount($hGUIList)>0 then
		$random=Random(0,_GUICtrlListView_GetItemCount($hGUIList)-1,1)
		if _GUICtrlListView_GetItemCount($hGUIList)>1 then
			while $random=$oldPlayed
				$random=Random(0,_GUICtrlListView_GetItemCount($hGUIList)-1,1)
			WEnd
		endif
		$folder=_GUICtrlListView_GetItemText($hGUIList,$random,0)
		$file=_GUICtrlListView_GetItemText($hGUIList,$random,1)
		if $oldPlayed<>-1 then
			GUICtrlSetBkColor(_GUICtrlListView_GetItemParam($hGUIList, $oldPlayed),$Colors[6])
		endif
		$oldPlayed=$random
		GUICtrlSetBkColor(_GUICtrlListView_GetItemParam($hGUIList, $random),$Colors[4])
		$file = $folder&"\"&$file
		Play($file)
	endif
EndFunc

Func SongEnd()
	;sleep(1000)
	If $Mode = 0 Then
		ConsoleWrite("0")
		GUICtrlSetData($hGUIPosition, 0)
		if _GUICtrlListView_GetItemCount($hGUIList)-1<>$oldPlayed then
			Playnext()
		else
			_BASS_ChannelStop($MusicHandle)
			GUICtrlSetBkColor(_GUICtrlListView_GetItemParam($hGUIList, $oldPlayed),$Colors[6])
			GUICtrlSetData($hGUIPlayPause,ChrW(9658)&@CRLF)
			$oldPlayed=-1
			$isPlaying=-1
		endif
	ElseIf $Mode = 1 Then
		ConsoleWrite("1")
		Playnext()
		GUICtrlSetData($hGUIPosition, 0)
	ElseIf $Mode = 2 Then
		ConsoleWrite("2")
		;_BASS_ChannelSetPosition($MusicHandle, 0, $BASS_POS_BYTE)
		$MusicHandleOld=$MusicHandle
		$MusicHandle = _BASS_StreamCreateFile(False, _BASS_ChannelGetInfo($MusicHandleOld)[7], 0, 0, 0)
		If $outFading = True Then Fade(1)
		if $aktDevice[0]<>-1 then
			_BASS_ChannelSetDevice($MusicHandle,$aktDevice[0]+1)
		endif
		_BASS_ChannelPlay($MusicHandle, 1)
		_BASS_ChannelSetAttribute($MusicHandle, $BASS_ATTRIB_VOL, GUICtrlRead($hGUIEQVolumeSlider)/100)
		_BASS_ChannelSetAttribute($MusicHandle, $BASS_ATTRIB_FREQ, GUICtrlRead($hGUIEQSpeedSlider)*10)
		Fade(0)
		_BASS_ChannelStop($MusicHandleOld)
		$IsPlaying = 1
		GUICtrlSetData($hGUIPlayPause, "II")
		If $EQ Then EQAct()
		#cs
		if ($oldPlayed>-1 and $oldPlayed<_GUICtrlListView_GetItemCount($hGUIList)-1) and $file=_GUICtrlListView_GetItemText($hGUIList,$oldPlayed,1) then
			$folder=_GUICtrlListView_GetItemText($hGUIList,$oldPlayed,0)
			$file=_GUICtrlListView_GetItemText($hGUIList,$oldPlayed,1)
			Play($folder&"\"&$file)
			GUICtrlSetData($hGUIPosition, 0)
		else
			_BASS_ChannelStop($MusicHandle)
			GUICtrlSetData($hGUIPlayPause,ChrW(9658)&@CRLF)
			$oldPlayed=-1
			$isPlaying=-1
		endif
		#ce
	ElseIf $Mode = 3 Then
		ConsoleWrite("3")
		PlayRandom()
		GUICtrlSetData($hGUIPosition, 0)
	EndIf
	$iPlaying=0
EndFunc

Func _WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam)
	_TLE_WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam,$oExplorer)
	Local $tNMCOMBOBOXEX = DllStructCreate($tagNMCOMBOBOXEX, $ilParam)
    Local $hWndFrom = DllStructGetData($tNMCOMBOBOXEX, 'hWndFrom')
    Local $Code = DllStructGetData($tNMCOMBOBOXEX, 'Code')
	Switch $hWndFrom
        Case GUICtrlGetHandle($hGUIList)
            Switch $Code
                Case $NM_DBLCLK
                    _ListContextPlay()
            EndSwitch
    EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_NOTIFY

Func MY_WM_COMMAND($hWnd, $msg, $wParam, $lParam)
	#cs
    Local $nNotifyCode = _HiWord($wParam)
    Local $nID = _LoWord($wParam)
 ; Local $hCtrl = $lParam
    Switch $lParam
    Case $hGUIDeviceCombo
            Switch $nNotifyCode
				Case $CBN_SELCHANGE
					_setDevice()
        EndSwitch
    EndSwitch
    Return $GUI_RUNDEFMSG
	#ce
EndFunc ;==>MY_WM_COMMAND
Func _HiWord($x)
    Return BitShift($x, 16)
EndFunc ;==>_HiWord

Func _LoWord($x)
    Return BitAND($x, 0xFFFF)
EndFunc ;==>_LoWord

Func GetMusicData($Path, $rek = False, Const $s_FileTypes = "mp3|wma|m4a|aac|ogg", $b_First = True)
    If Not StringInStr(FileGetAttrib($Path), "D") Then _addFile($Path)
    Local Static $o_Shell
    Local Static $s_Pattern
    Local $s_Name
    If $b_First Then
        $o_Shell = ObjCreate("Shell.Application")
        $s_Pattern = "\.(?:" & $s_FileTypes & ")$"
        $Path = $o_Shell.NameSpace($Path)
        If @error Or $Path = "" Then Return SetError(1, @error, 0)
    EndIf
    For $i In $Path.Items
        $s_Name = $i.Name
        If $i.IsFolder And $rek Then
            GetMusicData($i.GetFolder(), "", True, False)
		 ElseIf StringRegExp($s_Name, $s_Pattern) Then
			$sText = StringTrimRight($i.Path, StringLen($s_Name) + 1) & "|" & $s_Name & "|" & $Path.GetDetailsOf($i, 21) & "|" & $Path.GetDetailsOf($i, 20) & "|" & $Path.GetDetailsOf($i, 14) & "|" & $Path.GetDetailsOf($i, 27)
            GUICtrlCreateListViewItem($sText, $hGUIList)
			_ArrayAdd($aPlaylist, $sText, 0, "/")
        EndIf
    Next
    If $b_First Then $o_Shell = 0 ; Shell Objekt wieder killen
EndFunc   ;==>GetMusicData

Func _LVDrop()
    	If $Dragging Then
		$Dragging = False
		If GUIGetCursorInfo($hGUI)[4] = $hGUIList Then
			$ar = _GUICtrlListView_GetSelectedIndices($FolderList, True)
			_GUICtrlListView_BeginUpdate($hGUIList)
			AdlibRegister("_setToolTip", 1000)
			AdlibRegister("_aktToolTip", 10)
			For $i = 1 To UBound($ar) - 1 Step 1
				;3(_TLE_getActPath($oExplorer)&"\"&_GUICtrlListView_GetItemText($FolderList,$ar[$i],0))
					GetMusicData(_TLE_getActPath($oExplorer) & "\" & _GUICtrlListView_GetItemText($FolderList, $ar[$i], 0))
			Next
			AdlibUnRegister("_setToolTip")
			AdlibUnRegister("_aktToolTip")
			_GUICtrlListView_EndUpdate($hGUIList)
		EndIf
		ToolTip("")
	EndIf
	If $TDragging Then
		$ctrl = ControlGetPos($hGUI, "", $hGUIList)
		$mouse = MouseGetPos()
		$win = WinGetPos($hGUI)
		ToolTip("")
		$TDragging = False
		If ($mouse[0] - $win[0] > $ctrl[0] And $mouse[0] - $win[0] < $ctrl[0] + $ctrl[2] And $mouse[1] - $win[1] > $ctrl[1] And $mouse[1] - $win[1] < $ctrl[1] + $ctrl[3]) Then
			_GUICtrlListView_BeginUpdate($hGUIList)
			AdlibRegister("_setToolTip", 1000)
			AdlibRegister("_aktToolTip", 10)
			;_addFile(_TLE_getActPath($oExplorer),true)
			GetMusicData(_TLE_getActPath($oExplorer), True)
			AdlibUnRegister("_setToolTip")
			AdlibUnRegister("_aktToolTip")
			_GUICtrlListView_EndUpdate($hGUIList)
		EndIf
		ToolTip("")
	EndIf
	If $PDragging Then
		$PDragging = False
		Local $aItem = _GUICtrlListView_HitTest(GUICtrlGetHandle($hGUIList))
		If $aItem[0] <> $iDropItem And $aItem[0] <> -1 Then
			Local $aItemText = _GUICtrlListView_GetItemTextArray($hGUIList, $iDropItem)
			_GUICtrlListView_DeleteItem(GUICtrlGetHandle($hGUIList), $iDropItem)
			Local $InsItem = _GUICtrlListView_InsertItem($hGUIList, $aItemText[0], $aItem[0])
			For $i = 1 To UBound($aItemText) - 1 Step 1
				_GUICtrlListView_SetItemText($hGUIList, $InsItem, $aItemText[$i], $i - 1)
			Next
			_GUICtrlListView_SetItemSelected($hGUIList, $InsItem)
			_GUICtrlListView_SetItemFocused($hGUIList, $InsItem)
		EndIf
	EndIf
	;if $Resize<>-1 then
	;$Resize=-1
	;endif
	$CheckVolumeSlider = False
EndFunc   ;==>_LVDrop

Func _LVMove()
    if $PDragging then
        Local $aItem = _GUICtrlListView_HitTest(GUICtrlGetHandle($hGUIList))
		if $aItem[0]<>-1 then
			_GUICtrlListView_SetItemSelected($hGUIList, -1, False)
			_GUICtrlListView_SetItemSelected($hGUIList, $aItem[0])
		endif
    EndIf
EndFunc   ;==>_LVMove

Func _LVDrag()
	$ctrl=ControlGetPos($hGUI,"",$FolderList)
	$mouse=MouseGetPos()
	$win=WinGetPos($hGUI)
	if ($mouse[0]-$win[0]>$ctrl[0] and $mouse[0]-$win[0]<$ctrl[0]+$ctrl[2] and $mouse[1]-$win[1]>$ctrl[1] and $mouse[1]-$win[1]<$ctrl[1]+$ctrl[3]) and _IsPressed(01) then
		$Dragging=true
	endif
	$ctrl=ControlGetPos($hGUI,"",$FolderTree)
	if ($mouse[0]-$win[0]>$ctrl[0] and $mouse[0]-$win[0]<$ctrl[0]+$ctrl[2] and $mouse[1]-$win[1]>$ctrl[1] and $mouse[1]-$win[1]<$ctrl[1]+$ctrl[3]) and _IsPressed(01) then
		$TDragging=true
	endif
	$ctrl=ControlGetPos($hGUI,"",$hGUIList)
	if ($mouse[0]-$win[0]>$ctrl[0] and $mouse[0]-$win[0]<$ctrl[0]+$ctrl[2] and $mouse[1]-$win[1]>$ctrl[1] and $mouse[1]-$win[1]<$ctrl[1]+$ctrl[3]) then
		$PDragging=true
		Local $aItem = _GUICtrlListView_HitTest(GUICtrlGetHandle($hGUIList))
		$iDropItem = $aItem[0]
	endif
	$CheckVolumeSlider=true
EndFunc   ;==>_LVDrag

Func _aktToolTip()
	if $ToolTipText<>"-1" then
		ToolTip($ToolTipText)
	else
		ToolTip("")
	endif
EndFunc

Func _setToolTip()
	if WinActive($hGUI) then
		if StringSplit($ToolTipText,".")[0]=4 or $ToolTipText="-1" then
			$ToolTipText="Lade Playlist "
		else
			$ToolTipText&="."
		endif
		ToolTip($ToolTipText)
	elseif $ToolTipText<>"-1" then
		$ToolTipText="-1"
		ToolTip("")
	endif
EndFunc
#cs
Func FileSplitDir($file)
	Local $count = StringInStr($file, "\", 2, -1)
	Local $return = [StringLeft($file, $count-1), StringRight($file, $count+1)]
	return $return
EndFunc
#ce
Func _addFile($file, $all=false)
	If StringInStr($file, ".mp3") or StringInStr($file, ".wav") or StringInStr($file, ".wma") or StringInStr($file, ".m4a") or StringInStr($file, ".aac") or StringInStr($file, ".ogg") Then
		$ar=StringSplit($file,"\")
		$string=""
		for $i=1 to UBound($ar)-2 step 1
			$string&=$ar[$i]
			if $i<> UBound($ar)-2 then
				$string&="\"
			endif
		next
		$text=_GetExtProperty($file,-1)
		If IsArray($text) = False Then Return -1
		$aLen=StringSplit($text[27],":")
		if $aLen[0]>1 then
			$Length=int($aLen[1])*60*60+int($aLen[2])*60+int($aLen[3])
		Else
			Return -1
		endif
		$Bitrate = StringReplace($text[28], "kBit/s", "")
		$sText = $string&"|"&$ar[$ar[0]] &"|"& $text[21] &"|"& $text[20] &"|"& $text[14] &"|"& $text[27]&"|"&$Bitrate
		_ArrayAdd($aPlaylist, $sText)
		$New = GUICtrlCreateListViewItem($sText, $hGUIList)
		GUICtrlSetBkColor($New,$Colors[6])
		GUICtrlSetColor($New,$Colors[7])
	else
		if StringInStr(FileGetAttrib($file),"D") then
			$search=FileFindFirstFile($file&"\"&"*.*")
			while 1
				$datei=FileFindNextFile($search)
				if @error then
					ExitLoop
				EndIf
				if Not @extended then
					_addFile($file&"\"&$datei)
				endif
				if @extended and $all then
					_addFile($file&"\"&$datei,true)
				endif
			WEnd
		EndIf
	EndIf
EndFunc

Func _getTimeFromSeconds($seconds)
	$Timed=$seconds
	$string=""
	if int($Timed/60/60)>0 then
		if int($Timed/60/60)>9 then
			$string&=int($Timed/60/60)&":"
		else
			$string&="0"&int($Timed/60/60)&":"
		endif
		$Timed-=int($Timed/60/60)*60*60
	else
		$string&="00:"
	endif
	if int($Timed/60)>0 then
		if int($Timed/60)>9 then
			$string&=int($Timed/60)&":"
		else
			$string&="0"&int($Timed/60)&":"
		endif
		$Timed-=int($Timed/60)*60
	else
		$string&="00:"
	endif
	if $Timed>0 then
		if $Timed>9 then
			$string&=$Timed
		else
			$string&="0"&$Timed
		endif
	Else
		$string&="00"
	endif
	return $string
EndFunc

Func _GetExtProperty($sPath, $iProp)
	Local $sFile, $sDir, $oDir, $oFile, $aProperty, $sProperty
	If not FileExists($sPath) then return -1
		$sFile = StringTrimLeft($sPath, StringInStr($sPath, "\", 0, -1))
		$sDir = StringTrimRight($sPath, (StringLen($sPath) - StringInStr($sPath, "\", 0, -1)))
		$oDir = $oShellApp.NameSpace ($sDir)
		$oFile = $oDir.Parsename ($sFile)
			Local $aProperty[35]
			For $i = 0 To 34
				$aProperty[$i] = $oDir.GetDetailsOf ($oFile, $i)
			Next
			Return $aProperty
EndFunc   ;==>_GetExtProperty

Func _Hover_Func()
	for $i=0 to UBound($HoverControls)-1 step 1
		$ctrl=$HoverControls[$i][0]
		if GUIGetCursorInfo($hGUI)[4] = $ctrl then
			$HoverControls[$i][1]=true
			Call($HoverControls[$i][2],true)
		elseif $HoverControls[$i][1] then
			$HoverControls[$i][1]=false
			Call($HoverControls[$i][2],false)
		endif
	next
EndFunc

Func _MinimizeHovered($bool)
	if $bool then
		GUICtrlSetBkColor($MainGui_MinimizeButton,$Colors[3])
	else
		GUICtrlSetBkColor($MainGui_MinimizeButton,$Colors[1])
	endif
EndFunc

Func _CloseHovered($bool)
	if $bool then
		GUICtrlSetBkColor($MainGui_CloseButton,$Colors[2])
	else
		GUICtrlSetBkColor($MainGui_CloseButton,$Colors[1])
	endif
EndFunc

Func SetBitmap($hGUI, $hImage, $iOpacity)    ; lade hintergrundbild und mache den hintergrund transparent
    Local $hScrDC, $hMemDC, $hBitmap, $hOld, $pSize, $tSize, $pSource, $tSource, $pBlend, $tBlend

    $hScrDC = _WinAPI_GetDC(0)
    $hMemDC = _WinAPI_CreateCompatibleDC($hScrDC)
    $hBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hImage)
    $hOld = _WinAPI_SelectObject($hMemDC, $hBitmap)
    $tSize = DllStructCreate($tagSIZE)
    $pSize = DllStructGetPtr($tSize)
    DllStructSetData($tSize, "X", _GDIPlus_ImageGetWidth($hImage))
    DllStructSetData($tSize, "Y", _GDIPlus_ImageGetHeight($hImage))
    $tSource = DllStructCreate($tagPOINT)
    $pSource = DllStructGetPtr($tSource)
    $tBlend = DllStructCreate($tagBLENDFUNCTION)
    $pBlend = DllStructGetPtr($tBlend)
    DllStructSetData($tBlend, "Alpha", $iOpacity)
    DllStructSetData($tBlend, "Format", $AC_SRC_ALPHA)
    _WinAPI_UpdateLayeredWindow($hGUI, $hScrDC, 0, $pSize, $hMemDC, $pSource, 0, $pBlend, $ULW_ALPHA)
    _WinAPI_ReleaseDC(0, $hScrDC)
    _WinAPI_SelectObject($hMemDC, $hOld)
    _WinAPI_DeleteObject($hBitmap)
    _WinAPI_DeleteDC($hMemDC)
EndFunc

Func _RegisterHover($ControlID,$Func)
	ReDim $HoverControls[UBound($HoverControls)+1][3]
	$HoverControls[UBound($HoverControls)-1][0]=$ControlID
	$HoverControls[UBound($HoverControls)-1][1]=false
	$HoverControls[UBound($HoverControls)-1][2]=$Func
EndFunc

Func EQShow()
	for $i = 0 to UBound($hGUIEQItemSlider)-1 step +1
		If GUIGetCursorInfo($hGUIEQ)[4] = $hGUIEQItemSlider[$i] and _IsPressed(01) Then
			While _IsPressed(01)
				sleep(50)
				$Setting = Round(GUICtrlRead($hGUIEQItemSlider[$i])/100, 2)
				If $Setting > 0 Then $Setting = "+"&$Setting
				$Setting&= " db"
				ToolTip($Setting, Default, Default, Default, Default, 4)
			WEnd
			ToolTip("")
		EndIf
		PosItems()
	Next
	If GUIGetCursorInfo($hGUIEQ)[4] = $hGUIEQVolumeSlider and _IsPressed(01) Then
			While _IsPressed(01)
				sleep(50)
				$Setting = Round(GUICtrlRead($hGUIEQVolumeSlider))
				ToolTip($Setting, Default, Default, Default, Default, 4)
				_BASS_ChannelSetAttribute($MusicHandle, $BASS_ATTRIB_VOL, GUICtrlRead($hGUIEQVolumeSlider)/100)
				$iVolumeSetting = GUICtrlRead($hGUIEQVolumeSlider)/100
			WEnd
		ToolTip("")
	EndIf
	If GUIGetCursorInfo($hGUIEQ)[4] = $hGUIEQSpeedSlider and _IsPressed(01) Then
			While _IsPressed(01)
				sleep(50)
				$Setting = "x"&round(((GUICtrlRead($hGUIEQSpeedSlider)*10)/$iSpeedStandard)/10, 2)
				ToolTip($Setting, Default, Default, Default, Default, 4)
				$iSpeedSetting = GUICtrlRead($hGUIEQSpeedSlider)*10
				_BASS_ChannelSetAttribute($MusicHandle, $BASS_ATTRIB_FREQ, $iSpeedSetting)
			WEnd
		ToolTip("")
	EndIf
EndFunc

Func EQCheck()
	Local $Freqs[0], $Sets[0]
	for $i = 0 to UBound($hGUIEQItemInput)-1 step +1
		If (GUICtrlRead($hGUIEQItemInput[$i]) <> "0" or "") and (GUICtrlRead($hGUIEQItemSlider[$i]) <> 0) Then
			_ArrayAdd($Freqs, Round(GUICtrlRead($hGUIEQItemInput[$i]), 2))
			_ArrayAdd($Sets, Round(GUICtrlRead($hGUIEQItemSlider[$i])/100, 2))
		EndIf
	Next
	If UBound($Freqs) <> UBound($aEQSettingFreq) Then
		$aEQSettingFreq = $Freqs
		$aEQSettingSet = $Sets
		EQAct()
		Return True
	EndIf
	for $i = 0 to UBound($Freqs)-1 step +1
		If $Freqs[$i] <> $aEQSettingFreq[$i] or $Sets[$i] <> $aEQSettingSet[$i] Then
			$aEQSettingFreq = $Freqs
			$aEQSettingSet = $Sets
			EQAct()
			Return True
		EndIf
	Next
EndFunc

Func EQAddFreq()
	EQAddFreqEx(0, 0)
EndFunc

Func EQAddFreqEx($fFreq = 0, $fSet = 0)
	GUISwitch($hGUIEQ)
    _ArrayAdd($hGUIEQItemInput, GUICtrlCreateInput($fFreq, GUIx(5), GUIy(5) + (UBound($hGUIEQItemInput)+2) * GUIy(50), GUIx(50), GUIy(40), $ES_RIGHT))
   GUICtrlSetBkColor(-1, $Colors[6])
	_ArrayAdd($hGUIEQItemSlider, GUICtrlCreateSlider(GUIx(5 + 50 + 5), GUIy(5) + (UBound($hGUIEQItemInput)+2) * GUIy(50), GUIx(100), GUIy(40), $TBS_HORZ))
   GUICtrlSetBkColor(-1, $Colors[6])
   GUICtrlSetLimit(-1, $EQMax*100, $EQMin*100)
   GUICtrlSetData(-1, $fSet*100)
	$ScrollHeight = GUIy(5 + (UBound($hGUIEQItemInput)+2) * 50)
    _GUIScrollBars_Generate($hGUIEQ, 0, $ScrollHeight)
	PosItems()
	GUISwitch($hGUI)
EndFunc   ;==>EQAddFreq

Func EQGetSetting()
	Local $Freqs[0], $Sets[0]
	for $i = 0 to UBound($hGUIEQItemInput)-1 step +1
		If (GUICtrlRead($hGUIEQItemInput[$i]) <> "0" or "") and (GUICtrlRead($hGUIEQItemSlider[$i]) <> 0) Then
			_ArrayAdd($Freqs, Round(GUICtrlRead($hGUIEQItemInput[$i]), 2))
			_ArrayAdd($Sets, Round(GUICtrlRead($hGUIEQItemSlider[$i])/100, 2))
		EndIf
	Next
	If UBound($Freqs) >= 1 Then
		Local $Settings[2][UBound($Freqs)]
		for $i = 0 to UBound($Freqs)-1 step +1
			$Settings[0][$i] = $Freqs[$i]
			$Settings[1][$i] = $Sets[$i]
		Next
		Return $Settings
	Else
		Return 0
	EndIf
EndFunc

Func EQDelete()
	GUISwitch($hGUIEQ)
	EQSortFreqs()
	for $i = UBound($hGUIEQItemInput) -1 to 0 step -1
		If Number(GUICtrlRead($hGUIEQItemInput[$i])) <= 0 Then
			GUICtrlDelete($hGUIEQItemInput[$i])
			GUICtrlDelete($hGUIEQItemSlider[$i])
			_ArrayDelete($hGUIEQItemInput, $i)
			_ArrayDelete($hGUIEQItemSlider, $i)
		EndIf
	Next
	$ScrollHeight = GUIy(5 + UBound($hGUIEQItemInput) * 50)
	_GUIScrollBars_Generate($hGUIEQ, 0, $ScrollHeight)
	Global $Stop = True
	PosItems()
	GUISwitch($hGUI)
	$bDeleteEmpty = False
	If $EQ  Then EQAct()
EndFunc

Func EQDeleteReg()
	$bDeleteEmpty = True
EndFunc

Func PosItems()
	EQSortFreqs()
	GUICtrlSetPos($hGUIEQVolumeLabel, GUIx(5), _GUIScrollBars_Locate_Ctrl($hGUIEQ, 0, 0)[1] + GUIy(5 + 0 * 50), GUIx(50), GUIy(40))
	GUICtrlSetPos($hGUIEQVolumeSlider, GUIx(5 + 50 + 5), _GUIScrollBars_Locate_Ctrl($hGUIEQ, 0, 0)[1] + GUIy(5 + 0 * 50), GUIx(100), GUIy(40))
   GUICtrlSetPos($hGUIEQSpeedLabel, GUIx(5), _GUIScrollBars_Locate_Ctrl($hGUIEQ, 0, 0)[1] + GUIy(5 + 1 * 50), GUIx(50), GUIy(40))
	GUICtrlSetPos($hGUIEQSpeedSlider, GUIx(5 + 50 + 5), _GUIScrollBars_Locate_Ctrl($hGUIEQ, 0, 0)[1] + GUIy(5 + 1 * 50), GUIx(100), GUIy(40))
   For $i = 0 To UBound($hGUIEQItemInput) - 1 Step +1
		GUICtrlSetPos($hGUIEQItemInput[$i], GUIx(5), _GUIScrollBars_Locate_Ctrl($hGUIEQ, 0, 0)[1] + GUIy(5 + ($i+2) * 50), GUIx(50), GUIy(40))
		GUICtrlSetPos($hGUIEQItemSlider[$i], GUIx(5 + 50 + 5), _GUIScrollBars_Locate_Ctrl($hGUIEQ, 0, 0)[1] + GUIy(5 + ($i+2) * 50), GUIx(100), GUIy(40))
	Next
EndFunc

Func EQSortFreqs()
	Local $aHelpListItemInput[UBound($hGUIEQItemInput)]
	Local $aHelpListText[UBound($hGUIEQItemInput)]
	Local $aHelpListItemSlider[UBound($hGUIEQItemInput)]
    for $i = 0 to UBound($hGUIEQItemInput)-1 step +1
		$aHelpListItemInput[$i] = $hGUIEQItemInput[$i]
		$aHelpListItemSlider[$i] = $hGUIEQItemSlider[$i]
		$aHelpListText[$i] = GUICtrlRead($hGUIEQItemInput[$i])
	 Next
	for $i = 0 to UBound($hGUIEQItemInput)-1 step +1
		$iMax = _ArraySearch($aHelpListText, _ArrayMax($aHelpListText))
		If $iMax < 0 Then $iMax = 0
		$hGUIEQItemInput[$i] = $aHelpListItemInput[$iMax]
		$hGUIEQItemSlider[$i] = $aHelpListItemSlider[$iMax]
		_ArrayDelete($aHelpListItemInput, $iMax)
		_ArrayDelete($aHelpListItemSlider, $iMax)
		_ArrayDelete($aHelpListText, $iMax)
	Next
EndFunc

Func EQOnOff()
	If $EQ Then
		$EQ = False
		GUICtrlSetData($hGUISwitchEQ, "Off")
		EQAct()
	Else
		$EQ = True
		GUICtrlSetData($hGUISwitchEQ, "On")
		EQAct()
	EndIf
EndFunc

Func PassOnOff()
	If $bPassword Then
		If InputBox("Disable Password", "Type in the password:", "", "*") = $sPassword Then
			$bPassword = False
			GUICtrlSetBkColor($hGUIPassword, $Colors[1])
		Else
			MsgBox(16, "Wrong Password", "You entered the wrong password")
		EndIf
	Else
		$sPassword = InputBox("Enable Password", "Type in the password:", $sPassword, "*")
		$bPassword = True
		GUICtrlSetBkColor($hGUIPassword, $Colors[3])
	EndIf
EndFunc

Func SetAccels($Set = 1)
	If not $Set and $AccelsOn Then
		Local $aGUIAccels = 0
		$AccelsOn = False
		GUISetAccelerators($aGUIAccels, $hGUI)
	ElseIf $Set and not $AccelsOn Then
		Local $aGUIAccels[5][2] = [["{space}", $hGUIPlayPause], ["{right}", $hGUIForwards], ["{left}", $hGUIBackwards], ["^{a}", $hGUIDummySelectAll], ["{DEL}", $hGUIListContextDelete]]
		$AccelsOn = True
		GUISetAccelerators($aGUIAccels, $hGUI)
	EndIf
EndFunc

Func DummySelectAll()
	Local $Ctrl = ControlGetHandle($hGUI, "", ControlGetFocus($hGUI))
	If $Ctrl = ControlGetHandle($hGUI, "", $hGUIList) Then
		for $i = 0 to _GUICtrlListView_GetItemCount($hGUIList)-1 step +1
			_GUICtrlListView_SetItemSelected($hGUIList, $i)
		Next
	ElseIf $Ctrl = ControlGetHandle($hGUI, "", $FolderList) Then
		for $i = 0 to _GUICtrlListView_GetItemCount($FolderList)-1 step +1
			_GUICtrlListView_SetItemSelected($FolderList, $i)
		Next
	EndIf
EndFunc

Func SyncTime()
	GUICtrlSetData($hGUITime, @HOUR&":"&@MIN&":"&@SEC)
EndFunc

Func GUIx($Number)
	return $MainGui_Width/1000*$Number
EndFunc

Func GUIy($Number)
	return $MainGui_Height/1000*$Number
EndFunc
#EndRegion